// ------------------------------------------------------------------------------
// UPnPNX
//
// Lz[y[WŌJĂ\[X𗘗pĂ܂B
// ǂӂ -ŕsȓX-l URL:http://www.bosuke.mine.nu/blog/ 
//
// ------------------------------------------------------------------------------
#include "upnp.h"
#include <malloc.h>
#include <ws2tcpip.h>
#include <algorithm>
#include <strstream>
#include <sstream>
#include <Wininet.h>


namespace
{
	const char* UPNP_GROUP = "239.255.255.250";
	const unsigned short UPNP_PORT = 1900;
	const DWORD BUFFER_SIZE = 2048;
}

//////////////////////////////////////////////////
//winsock
//////////////////////////////////////////////////

bool YMSSDPDiscover::mInitialized = false;

bool YMSSDPDiscover::Initialize()
{
	if(!mInitialized)
	{
		WSADATA data;
		if(WSAStartup(MAKEWORD(2,0),&data) != 0)
		{
			return false;
		}
		if(LOBYTE(data.wVersion) != 2 || HIBYTE(data.wVersion) != 0)
		{
			WSACleanup();
			return false;
		}
		mInitialized = true;
	}
	return true;
}

void YMSSDPDiscover::Uninitialize()
{
	if(mInitialized)
	{
		WSACleanup();
		mInitialized = false;
	}
}

YMSSDPDiscover::YMSSDPDiscover()
:mSocket(INVALID_SOCKET),mLastError(0)
{
}

YMSSDPDiscover::~YMSSDPDiscover()
{
	Close();
}

//////////////////////////////////////////////////
// \PbgI[vƃN[Y
//////////////////////////////////////////////////

bool YMSSDPDiscover::Open()
{
	mLastError = 0;
	if(mSocket != INVALID_SOCKET)
	{
		return true;
	}

	//UDP\Pbg[
	mSocket = socket(AF_INET,SOCK_DGRAM,0);
	if(mSocket == INVALID_SOCKET)
	{
		mLastError = WSAGetLastError();
		return false;
	}

	//󂢂Ă|[gbind
	sockaddr_in addr;
	ZeroMemory(&addr,sizeof(addr));
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	unsigned short port = 20000;
	while(1)
	{
		addr.sin_port = htons(port);
		if(bind(mSocket,(sockaddr*)&addr,sizeof(addr)) == 0)
		{
			//
			break;
		}
		int err = WSAGetLastError();
		if(err == WSAEADDRINUSE)
		{
			//gp
			++port;
		}
		else
		{
			//G[
			mLastError = err;
			closesocket(mSocket);
			mSocket = INVALID_SOCKET;
			return false;
		}
	}

	//TTLEmubLOݒ
	const char TTL = 4;
	unsigned long flags = 1;
	setsockopt(mSocket,IPPROTO_IP,IP_MULTICAST_TTL,&TTL,sizeof(TTL));
	ioctlsocket(mSocket,FIONBIO,&flags);

	//CxgIuWFNg쐬
	mEvent = WSACreateEvent();

	return true;
}

void YMSSDPDiscover::Close()
{
	mLastError = 0;
	if(mSocket != INVALID_SOCKET)
	{
		closesocket(mSocket);
		mSocket = INVALID_SOCKET;
		mLastError = WSAGetLastError();
		WSACloseEvent(mEvent);
	}
	mSTList.clear();
}

//////////////////////////////////////////////////
// M-SEARCHM
//////////////////////////////////////////////////

bool YMSSDPDiscover::Send(const char* st)
{
	mLastError = 0;

	//IPAhXXg擾
	DWORD bufferSize = 0;
	SOCKET s = socket(AF_INET,SOCK_DGRAM,0);
	WSAIoctl(s,SIO_ADDRESS_LIST_QUERY,NULL,0,NULL,0,&bufferSize,NULL,NULL);
	if(bufferSize == 0)
	{
		mLastError = WSAGetLastError();
		closesocket(s);
		return false;
	}
	SOCKET_ADDRESS_LIST* list = (SOCKET_ADDRESS_LIST*)_alloca(bufferSize);
	if(WSAIoctl(s,SIO_ADDRESS_LIST_QUERY,NULL,0,list,bufferSize,&bufferSize,NULL,NULL) == SOCKET_ERROR)
	{
		mLastError = WSAGetLastError();
		closesocket(s);
		return false;
	}
	closesocket(s);

	//Mf[^쐬
	std::string data = "M-SEARCH * HTTP/1.1\r\nMX: 3\r\nHOST: 239.255.255.250:1900\r\nMAN: \"ssdp:discover\"\r\nST: ";
	data += st;
	data += "\r\n\r\n";

	//f[^񂬂}`LXgĂ
	sockaddr_in dest_addr;
	ZeroMemory(&dest_addr,sizeof(dest_addr));
	dest_addr.sin_family = AF_INET;
	dest_addr.sin_addr.s_addr = inet_addr(UPNP_GROUP);
	dest_addr.sin_port = htons(UPNP_PORT);

	in_addr interface_addr;
	ZeroMemory(&interface_addr,sizeof(interface_addr));

	bool ok = false;
	for(int i = 0; i < list->iAddressCount; ++i)
	{
		interface_addr.s_addr = ((sockaddr_in*)list->Address[i].lpSockaddr)->sin_addr.s_addr;
		if(setsockopt(mSocket,IPPROTO_IP,IP_MULTICAST_IF,(char*)&interface_addr, sizeof(interface_addr)) == 0)
		{
			if(sendto(mSocket,data.data(),data.length(),0,(sockaddr*)&dest_addr,sizeof(dest_addr)) > 0)
			{
				ok = true;
			}
			else
			{
				mLastError = WSAGetLastError();
			}
		}
		else
		{
			mLastError = WSAGetLastError();
		}
	}

	//Pł܂邱ƂłǂƂ
	if(ok)
	{
		mLastError = 0;
		
		//ST̃XgɂԂ
		if(std::find(mSTList.begin(),mSTList.end(),st) == mSTList.end())
		{
			mSTList.push_back(st);
		}
	}
	return ok;
}


//////////////////////////////////////////////////
// f[^M
//////////////////////////////////////////////////
int YMSSDPDiscover::Recv(LocationInfo& info,DWORD timeout)
{

	mLastError = 0;
	
	//w~ZJhf[^Mł܂ő҂
	WSAResetEvent(mEvent);
	if(WSAEventSelect(mSocket,mEvent,FD_READ) == SOCKET_ERROR)
	{
		mLastError = WSAGetLastError();
		return Error;
	}

	WSANETWORKEVENTS events;
	DWORD ret = WSAWaitForMultipleEvents(1,&mEvent,FALSE,timeout,FALSE);
	if(ret == WSA_WAIT_TIMEOUT)
	{
		return Timeout;
	}
	if(ret == WSA_WAIT_FAILED
		|| WSAEnumNetworkEvents(mSocket,mEvent,&events) != 0
		|| !(events.lNetworkEvents & FD_READ))
	{
		mLastError = WSAGetLastError();
		return Error;
	}

	//M
	char buffer[BUFFER_SIZE + 1];
	sockaddr_in addr;
	int addrLen = sizeof(addr);
	int readLen = recvfrom(mSocket,buffer,BUFFER_SIZE,0,(sockaddr*)&addr,&addrLen);
	if(readLen == SOCKET_ERROR)
	{
		mLastError = WSAGetLastError();
		return Error;
	}
	buffer[readLen] = '\0';

	//p[X
	LocationInfo tempInfo;
	std::istrstream input(buffer);
	std::string line;
	bool first = true;
	while(std::getline(input,line))
	{

		//ATLTRACE("recv:%s\n",line.c_str());
		
		if(first)
		{
			//200ȊO̓_|
			std::istringstream responseLine(line);
			std::string dummy;
			int code = 0;
			responseLine >> dummy >> code;
			if(code != 200)
			{
				return HttpError;
			}
			first = false;
		}
		else
		{
			//tB[hƒlɂ킯
			int index = line.find(':');
			if(index == std::string::npos)
			{
				continue;
			}
			std::string field = line.substr(0,index);
			if((index = line.find_first_not_of(' ',index + 1)) != std::string::npos)
			{
				std::string value = line.substr(index);
				if(!value.empty())
				{
					if(*value.rbegin() == '\r')
					{
						value = value.substr(0,value.length() - 1); 
					}
					if(stricmp(field.c_str(),"ST") == 0)
					{
						tempInfo.mST = value;
					}
					else if(stricmp(field.c_str(),"Location") == 0)
					{
						tempInfo.mLocation = value;
					}
				}
			}
		}
	}

	//l`FbN
	if(tempInfo.mST.empty()
		|| tempInfo.mLocation.empty()
		||std::find(mSTList.begin(),mSTList.end(),tempInfo.mST) == mSTList.end())
	{
		return NoData;
	}

	//OK
	info = tempInfo;

	return OK;
}

//////////////////////////////////////////////////
// controlURL̎擾
//////////////////////////////////////////////////
std::string YMSSDPDiscover::GetControlURL(const char* location,const char* st)
{
	std::string result;
	std::string baseURL;
	std::string relativeURL;

	//XML擾
	try
	{
		MSXML::IXMLHttpRequestPtr http;
		if(FAILED(http.CreateInstance(MSXML::CLSID_XMLHTTPRequest)))
		{
			return result;
		}
		http->open("GET",location,VARIANT_FALSE);
		http->send();
		if(http->status != 200)
		{
			return result;
		}
		MSXML::IXMLDOMDocumentPtr doc = http->responseXML;

		//controlURL擾
		std::string xPath = "//service[serviceType=\"";
		xPath += st;
		xPath += "\"]/controlURL";
		MSXML::IXMLDOMNodePtr controlURLNode = doc->selectSingleNode(xPath.c_str());
		if(controlURLNode)
		{
			relativeURL = controlURLNode->text;
		}
		else
		{
			return result;
		}

		
		//BASEURL擾
		MSXML::IXMLDOMNodePtr baseURLNode = doc->selectSingleNode("//URLBase");
		if(baseURLNode)
		{
			baseURL = baseURLNode->text;
		}
		else
		{
			baseURL = location;
		}
	}
	catch(_com_error&)
	{
		return result;
	}

	//URL
	DWORD size = 0;
	InternetCombineUrl(baseURL.c_str(),relativeURL.c_str(),NULL,&size,0);
	char* buf = (char*)_alloca(size);
	InternetCombineUrl(baseURL.c_str(),relativeURL.c_str(),buf,&size,0);
	result = buf;
	
	return result;
}




YMSoapAction::YMSoapAction(const char* serviceType,const char* actionName)
:mServiceType(serviceType),mActionName(actionName)
{
	CoInitialize(NULL);
}

YMSoapAction::~YMSoapAction()
{
	CoUninitialize();
}

void YMSoapAction::SetParameter(const char* field,const char* value)
{
	//p[^[Zbg
	mParameter[field] = value;
}

void YMSoapAction::ResetParameter()
{
	//p[^NA
	mParameter.clear();
}

int YMSoapAction::Invoke(const char* url)
{
	//Mf[^쐬

	try
	{
		MSXML::IXMLDOMDocumentPtr sendXML;
		if(FAILED(sendXML.CreateInstance(MSXML::CLSID_DOMDocument)))
		{
			return -1;
		}
		sendXML->async = VARIANT_FALSE;
		sendXML->preserveWhiteSpace = VARIANT_FALSE;
		sendXML->resolveExternals = VARIANT_FALSE;
		sendXML->loadXML("<?xml version=\"1.0\"?>"
			"<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">"
			"<SOAP-ENV:Body>"
			"</SOAP-ENV:Body>"
			"</SOAP-ENV:Envelope>");
		MSXML::IXMLDOMElementPtr body = sendXML->selectSingleNode("/SOAP-ENV:Envelope/SOAP-ENV:Body");

		std::string name = "m:" + mActionName;
		_variant_t varNodeType((short)MSXML::NODE_ELEMENT);
		MSXML::IXMLDOMNodePtr node = NULL;
		node = sendXML->createNode(varNodeType,name.c_str(),mServiceType.c_str());
		Parameters::const_iterator p;
		for(p = mParameter.begin(); p != mParameter.end(); ++p)
		{
			MSXML::IXMLDOMElementPtr param = sendXML->createElement(p->first.c_str());
			param->text = p->second.c_str();
			node->appendChild(param);
		}
		body->appendChild(node);

		//M
		MSXML::IXMLHttpRequestPtr http;
		if(FAILED(http.CreateInstance(MSXML::CLSID_XMLHTTPRequest)))
		{
			return -1;
		}
		if(FAILED(http->open("POST",url,VARIANT_FALSE)))
		{
			return -1;
		}
		std::string action = mServiceType + "#" + mActionName;
		http->setRequestHeader("SOAPAction",action.c_str());
		http->send(sendXML->xml);

		return http->status;
	}
	catch(_com_error&/* ex */)
	{
		//ATLTRACE((const char*)ex.Description());
		return -1;
	}
}
